#     file     : projects/PaminaIII/bin/EMME2Pamina.awk
#     project  : Pamina III simulation suite
#     author   : Marcus Rickert
#     RCS      : $Id: EMME2Pamina.awk,v 1.1 2005/04/30 10:10:15 mr Exp $
#     purpose  : converts EMME/2 network file to PAMINA link format
#
#     Copyright (C) 2005 :  Marcus Rickert

# TODO:
#

BEGIN {
    InNodeSection = 0;
    InLinkSection = 0;
    LinkID = 1;
    DefaultClass = 4;
}

/^t nodes init[[:blank:]]*$/ {
    InNodeSection = 1;
    next;
}

/^t links[[:blank:]]*$/ {
    InLinkSection = 1;
    next;
}

/^a/ {
    if (InNodeSection && DumpNodes > 0) {
        NodeID = $2;
        X = $3;
        Y = $4;
        print NodeID, X, Y;
    }
    if (InLinkSection && DumpLinks > 0) {
        FromNodeID = $2;
        ToNodeID = $3;        
        NrOfLanes = 1;
        Length = -1;
        Class = DefaultClass;
        SpeedLimit = $9 / 3.6; # convert from km/h to m/s
        FreeSpeed = SpeedLimit;
        printf "%d %d %d %d %.1f %d %.1f %.1f", 2*LinkID, FromNodeID, ToNodeID, NrOfLanes, Length, Class, SpeedLimit, FreeSpeed;
        print "" 2*LinkID+1, ToNodeID, FromNodeID, NrOfLanes, Length, Class, SpeedLimit, FreeSpeed;
        LinkID = LinkID + 1;
    }
    next;
}

/[[:blank:]]*/ {
    InLinkSection = 0;
    InNodeSection = 0;
}
