/*      file     : ParSim/ParSim.C
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: ParSim.C,v 1.5 2005/03/25 11:07:34 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TEnvironment.h>
#include <TCommunication.h>
#include <TParallel.h>

#include "TParSimSlave.h"
#include "TParSimMaster.h"

// ***FUNCTIONS*********************************************************************** 

int main(int sysargc, char *sysargv[])

{
    int             argc = sysargc;
    char          **argv = sysargv;
    TParSimSlave   *Slave = 0;
    TParSimMaster  *Master = 0;
    int             MasterExitCode = 0;

    Slave = new TParSimSlave(argc, argv);
    if (!Slave->Activate())
    {
        Print("cannot activate application slave");
        Environment->SetExitCode(Status_GeneralError);
        goto EndOfMethod;
    }
    if (Parallel->IsMaster())
    {
        Master = new TParSimMaster(Slave);

        if (!Master->Activate())
        {
            Print("cannot activate application master");
            Environment->SetExitCode(Status_GeneralError);
            goto EndOfMethod;
        }
        if (!Master->Run())
        {
            Print("during execution (master)");
            Environment->SetExitCode(Status_GeneralError);
            goto EndOfMethod;
        }
    }
    else
    {
        if (!Slave->Run())
        {
            Print("during execution (slave)");
            Environment->SetExitCode(Status_GeneralError);
            goto EndOfMethod;
        }
        // Communication->MessageLoop(TRUE);
    }
    
 EndOfMethod:

    if (Parallel)
    {
        Parallel->Quit();
        MasterExitCode = (int) Environment->GetExitCode();    
    }
    DeleteObject(Master);
    DeleteObject(Slave);
    return MasterExitCode;
}

// =================================================================================== 
#undef ParentClass
