/*      file     : TrafficData/TAsciiAccessoryReader.C
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TAsciiAccessoryReader.C,v 1.6 2005/03/29 17:12:48 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TLocation.h>

#include "TAccessory.h"

#include "TAsciiAccessoryReader.h"

// ***DEFINES************************************************************************* 

#define ACCESSORY_ASCII_TABLE_NAME "Accessories"
#define ACCESSORY_SCAN_PATTERN PARALLEL_ID_PRINTF_FORMAT

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass TAsciiDataTypeReader
// =================================================================================== 

TAsciiAccessoryReader::TAsciiAccessoryReader(const char *theBaseFilename) :

ParentClass(theBaseFilename, ACCESSORY_ASCII_TABLE_NAME, ACCESSORY_SCAN_PATTERN)

{    
}

// =================================================================================== 

void *
TAsciiAccessoryReader::CreateObject(const char *Line) const

{
    TAccessory          *Accessory = 0;
    TAccessoryConstData  ConstData;
    TParallelID          AccessoryID;
    double               LocationInMeters;
    static char          Format[64] = { 0 };

    if (0 == Format[0]) {
        sprintf(Format, "%s %s %s %%lf", PARALLEL_ID_PRINTF_FORMAT,
                PARALLEL_ID_PRINTF_FORMAT, PARALLEL_ID_PRINTF_FORMAT);
        Print(DM_FILE, "created scanf format %s", Format);
    }
    if (sscanf(Line, Format, &ConstData.EdgeID, &ConstData.DestNodeID,
               &AccessoryID, &LocationInMeters) != 4)
    {
        Error("too few parameters in line '%s'", Line);
        return 0;
    }

    //    Print("Format=%s EdgeID=%lld %Lu", Format, ConstData.EdgeID, ConstData.EdgeID);

    ConstData.AbsoluteLocation = MeterToLength(LocationInMeters);
    if ((Accessory = new TAccessory(AccessoryID, &ConstData)) == 0)
    {
        Error("cannot create TAccessory");
        return 0;
    }

    //    Print("New Accessory:%s", (char *) Accessory->GetInstanceName());

    return Accessory;
}

// =================================================================================== 
#undef ParentClass
