/*      file     : TrafficData/TEdgeInfo.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TEdgeInfo.h,v 1.5 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TEDGEINFO_H
#define TEDGEINFO_H

// ***INCLUDES************************************************************************ 

#include <TParallelObject.h>

// ***FORWARDS************************************************************************

class TBaseStream;
class TClassInfo;
class TDatabaseEdge;
class TTransferInfo;

// ***DEFINES************************************************************************* 

#define CLASS_EDGE_INFO          "EdgeInfo"

#define EDGE_THROUGHWAY_CLASS    1

// ***CLASSES************************************************************************* 

class TEdgeInfo : public TParallelObject

{
public:

    TEdgeInfo(TParallelID theParallelID);

    TEdgeInfo &
        operator = (const TDatabaseEdge &Info);

    static TEdgeInfo *
    GetPtr(TParallelID ID, bool Warn);

    static TClassInfo *ClassInfo;

    short  Level;
    short  Class;
    short  NrOfLanes;
    double Length;
    double SpeedLimit;
    double FreeSpeed;

private:
    
    virtual bool
        Decode(TBaseStream *Stream, TTransferInfo *TransferInfo);
    virtual bool
        Encode(TBaseStream *Stream, TTransferInfo *TransferInfo) const;
    virtual TString
        GetClassName(void) const;
    virtual TString
        GetInstanceName(void) const;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
