/*      file     : xparallel/TGraphEdgeInfo.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TGraphEdgeInfo.C,v 1.4 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TNode.h>
#include <TEdge.h>
#include <TAdjacenceInfo.h>

#include "TGraphEdgeInfo.h"

// ***GLOBAL VARIABLES**************************************************************** 

TClassInfo *TGraphEdgeInfo::ClassInfo = 0;

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass TParallelObject
// =================================================================================== 

TGraphEdgeInfo::TGraphEdgeInfo(TParallelID theParallelID) : 

ParentClass(ClassInfo, theParallelID)

{    
    FromColor = 0;
    ToColor = 0;
    EffectiveLength = INVALID;
}

// =================================================================================== 

TString
TGraphEdgeInfo::GetClassName(void) const

{
    return "TGraphEdgeInfo";
}

// =================================================================================== 

bool
TGraphEdgeInfo::LoadLocations(TInfoID AdjInfoID, TInfoID LocInfoID)

{
    TAdjacenceInfo *Adj;
    TNode          *FromNode;
    TNode          *ToNode;

    if ((Adj = (TAdjacenceInfo *) GetInfo(AdjInfoID)) == 0)
    {
        Error("LoadLocations: cannot get adjacence info");
        return FALSE;
    }
    if ((FromNode = Adj->GetFromNode(FALSE)))
        From = FromNode->Loc(LocInfoID);
    if ((ToNode = Adj->GetToNode(FALSE)))
        To = ToNode->Loc(LocInfoID);
    EffectiveLength = Adj->GetLength(LocInfoID);
    return TRUE;
}

// =================================================================================== 
#undef ParentClass

