/*      file     : TrafficData/TGridStat.i.C
        project  : Parallel Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TGridStat.i.C,v 1.3 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline double
TGridStat::GetDensity(void) const

{
    if (GetNrOfSites())
        return ((double) GetNrOfVehicles()) / (double) GetNrOfSites();
    else
        return INVALID_MEAN;
}

/* =================================================================================== */

inline double
TGridStat::GetFlow() const

{
    if (GetNrOfSites())
        return ((double) GetSumV()) / (double) GetNrOfSites();
    else
        return INVALID_MEAN;
}

/* =================================================================================== */

inline double
TGridStat::GetFreeSpeed(void) const

{
    return FreeSpeed;
}

/* =================================================================================== */

inline double
TGridStat::GetVMean(void) const

{
    if (GetNrOfVehicles())
        return (double) SumV / (double) GetNrOfVehicles();
    else
        return INVALID_MEAN;
}

/* =================================================================================== */

inline double
TGridStat::GetLengthInMeters(void) const

{
    if (Length == 0)
        Warning("GetLengthInMeters: zero length!");
    return SITE_LENGTH * Length;
}

/* =================================================================================== */

inline long
TGridStat::GetNrOfSites(void) const

{
    return Sites;
}

/* =================================================================================== */

inline long
TGridStat::GetNrOfVehicles(void) const

{
    return Count;
}

/* =================================================================================== */

inline long
TGridStat::GetSumV(void) const

{
    return SumV;
}

/* =================================================================================== */

inline long
TGridStat::GetSumV2(void) const

{
    return SumV2;
}

// =================================================================================== 



