/*      file     : common/LexYacc.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: LexYacc.h,v 1.6 2005/03/25 11:04:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef LEXYACC_H
#define LEXYACC_H

/* ***INCLUDES************************************************************************ */

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

/* ***EXTERNALS*********************************************************************** */

extern FILE *yyin;

/* ***PROTOTYPES********************************************************************** */
#ifdef __cplusplus
extern "C" {
#endif
    void
        LexDebug(const char *aString, ...);
    void
        LexSetConfig(void);
    void
        LexSetConfigString(const char *aString);
    void
        LexSetGroupname(void);
    void
        LexSetName(const char *aName);
    void
        LexSetString(const char *aString);
    void
        LexSetStringValue(const char *aString);
    void
        YaccDebug(const char *aString, ...);
#ifdef NO_MBS_INVALID
    int
        mbsinvalid(const char *);
#endif
#ifndef HAS_YYLEX_PROTO
    int 
        yylex(void);
#endif
    void
        yyerror(char *);
    int 
        yyparse(void);
#ifndef HAS_YYWRAP_PROTO
    int 
        yywrap(void);
#endif
#ifdef __cplusplus
}
#endif
/* ===================================================================================
// Local Variables:
// mode:c++
// End: */
#endif
