/*      file     : common/TAlarm.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TAlarm.h,v 1.3 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TALARM_H
#define TALARM_H

// ***INCLUDES************************************************************************ 
// ***FORWARDS************************************************************************

class TSignal;
class TString;

// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***CLASSES************************************************************************* 

class TAlarm : public TBaseObject

{
 public:

    TAlarm(TSignal *theSignalHandler);
    ~TAlarm(void);

    bool 
        Activate(long Interval);
    void
        Deactivate(void);
    void 
        Pause(void);

 private:
    
    virtual TString
        GetClassName(void) const;
#ifdef OLD_ALARM
    bool Active;
    struct itimerval OldTimer;
    TSignal *SignalHandler;
#else
    struct timeval Timer;
#endif
};

// ***EXTERNALS*********************************************************************** 
// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#endif
// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
