/*      file     : common/TEnumerator.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TEnumerator.h,v 1.6 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TENUMERATOR_H
#define TENUMERATOR_H

// ***INCLUDES************************************************************************ 

#include "TBaseObject.h"

// ***FORWARDS************************************************************************

class TContainer;

// ***CLASSES************************************************************************* 

/**
  */

class TEnumeratorPrimitive : public TBaseObject

{
public:

    TEnumeratorPrimitive(const TContainer *theContainer);

    operator TBaseObject * (void);

    inline TBaseObject *
    operator -> (void);

    inline long
    operator () (void);

    inline void
    operator ++ (int);

    inline void
    Enumerate(void);

    virtual TString
    GetClassName(void) const;

    inline TBaseObject *
    GetCurrent(void);

    inline TBaseObject *
    GetCurrentContainerEntry(void);

    inline TBaseObject *
    GetDataPtr(void);

    inline long
    GetIndex(void);

    inline void
    SetDataPtr(TBaseObject *theDataPtr);

    inline void
    SetIndex(long theIndex);

protected:

    TContainer  *Container;

private:

    TBaseObject *DataPtr;
    long         Index;
};

// ===================================================================================

template < class TData >
class TEnumerator : public TEnumeratorPrimitive

{
public:

    TEnumerator(const TContainer *theContainer);
    virtual ~TEnumerator(void);

    operator TData * (void);
    TData *
        operator -> (void);
};

// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#  include "TEnumerator.i.C"
#endif
// ***TEMPLATE METHODS**************************************************************** 
#if defined (INCLUDE_TEMPLATES) || defined(TEMPLATEBODIES)
#  include "TEnumerator.t.C"
#endif
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
