/*      file     : common/TParser.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TParser.C,v 1.11 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************

#include <string.h>
#include <errno.h>

#include <TDebug.h>
#include <TString.h>
#include <TParser.h>

// ***METHODS************************************************************************* 

#ifdef NO_INLINE
#include <TParser.i.C>
#endif

// =================================================================================== 
#define ParentClass TStream
// =================================================================================== 

TParser::TParser(int theNrOfTokens, char **theTokens, char *theDelimiters,
                 long theMaxInputLineLength) :

    ParentClass(theDelimiters, theMaxInputLineLength)
    
{
    NrOfTokens = theNrOfTokens;
    Tokens = theTokens;
}

// =================================================================================== 

TParser::~TParser(void)

{
}

// =================================================================================== 

bool
TParser::FindToken(long TokenID)

{
    while (CurrentToken AND GetTokenID() != TokenID)
        if (!ReadToken() AND !EndOfFile())
            return FALSE;
    return TRUE;
        
}

// =================================================================================== 

TString
TParser::GetClassName(void) const

{
    return "TParser";
}

// =================================================================================== 

int
TParser::GetTokenID(long ExpectedToken) const

{
    int i;
    
    if (CurrentToken == 0)
        return -1;
    for (i = 0; i < NrOfTokens; i++)
        if (Tokens[i] != 0 AND strcmp(CurrentToken, Tokens[i]) == 0)
            return i;
    if (ExpectedToken != -1)
        Warning("token '%s' expected, found '%s'", 
                Tokens[ExpectedToken], CurrentToken);
    return -1;
}

// =================================================================================== 
#undef ParentClass




