/*      file     : common/TStringContainerEntry.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TStringContainerEntry.h,v 1.4 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TSTRINGCONTAINERENTRY_H
#define TSTRINGCONTAINERENTRY_H

// ***INCLUDES************************************************************************ 

#include <stdio.h>

#include "TString.h"

#include "TContainerEntry.h"

// ***CLASSES************************************************************************* 

/**
  */

class TStringContainerEntryPrimitive : public TContainerEntry

{
public:

    TStringContainerEntryPrimitive(const char *theString = 0, TBaseObject *theDataPtr = 0);

    virtual TString
        GetClassName(void) const;
    virtual TString
        GetInstanceName(void) const;
    inline TString &
        GetString(void);
    inline const TString &
        GetString(void) const;

private:

    TString String;

    virtual int
        Compare(TBaseObject *OtherObject, int CompareCode) const;
};

// ===================================================================================

/** 
  */

template < class T >
class TStringContainerEntry : public TStringContainerEntryPrimitive

{
public:
    
    TStringContainerEntry(const char *theString = 0, T *theDataPtr = 0);

    operator T * (void);

private:

    virtual TBaseObject *
        Copy(void) const;
};

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TStringContainerEntry.i.C"
#endif

// ***TEMPLATE METHODS**************************************************************** 

#if defined (INCLUDE_TEMPLATES) || defined(TEMPLATEBODIES)
#  include "TStringContainerEntry.t.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
