/*      file     : common/TSynchronize.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TSynchronize.h,v 1.4 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TSYNCHRONIZE_H
#define TSYNCHRONIZE_H

// ***INCLUDES************************************************************************ 

#include <stdio.h>

#include <TBaseObject.h>
#include <TString.h>

// ***CLASSES************************************************************************* 

class TSynchronize : public TBaseObject

{
public:
    
    TSynchronize(void);
    virtual ~TSynchronize(void);
        
    bool
    Activate(const char *thePipeName, bool IsMaster);

    bool
    Deactivate();

    bool
    Step(long MyStep);

    bool
    Wait(long &MyStep, bool &ErrorFlag);

private:

    TString PipeName;
    bool    IsMaster;
    int     Read;
    int     Write;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
