/*      file     : common/Time.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: Time.C,v 1.3 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#ifdef USE_EPX_TIME
extern "C" 
{
#include <limits.h>
#include <epx/time.h>
}
#endif

#include "TEnvironment.h"
#include "Time.h"

// ***METHODS************************************************************************* 
#ifdef USE_EPX_TIME
void
EPX_GetTime(struct timeval *TimeVal)

{
    static unsigned int PreviousTime = 0;
    static long         EPX_sec = 0;
    static long         EPX_usec = 0;
    unsigned int        CurrentTime;
    unsigned int        Increase_usec;

    CurrentTime = TimeNow();
    if (CurrentTime > PreviousTime)     
        Increase_usec = CurrentTime - PreviousTime;
    else
    {
        Increase_usec = (UINT_MAX - (PreviousTime - CurrentTime)) + 1;
        Print("WARNING: timer overflow");
    }
    EPX_sec += Increase_usec / 1000000;
    EPX_usec += Increase_usec % 1000000;
    if (EPX_usec > 1000000)
    {
        EPX_sec++;
        EPX_usec -= 1000000;
    }
    PreviousTime = CurrentTime;
    TimeVal->tv_sec = EPX_sec;
    TimeVal->tv_usec = EPX_usec;
}
#endif
// =================================================================================== 
#undef ParentClass


