/*      file     : graphx/Graphx.C
        project  : Parallel Toolbox
        author   : Marcus Rickert
        objects  : GrWindow
        comments : Wrapper for graphx tools
        RCS      : $Id: Graphx.C,v 1.2 2005/03/25 11:06:10 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

/* ***INCLUDES************************************************************************ */

#include <Graphx.h>

/* ***METHODS************************************************************************* */
#ifdef INLINE_BUG
GrWindow &
GrWindow::operator<<(const GrLine &l) {
#ifdef DEBUG
    SETFUNC("GrWindow &GrWindow::operator<<(GrLine &)");
#endif
    grUsrDrawLine(theWindow,l.x1,l.y1,l.x2,l.y2,GetColor(l.color));
    return *this;
};
#endif
/* =================================================================================== */
#ifdef INLINE_BUG
GrWindow &
GrWindow::operator<<(const GrBox &b) {
#ifdef DEBUG
    SETFUNC("GrWindow &GrWindow::operator<<(GrBox &)");
#endif
    grUsrDrawBox(theWindow,b.x1,b.y1,b.x2,b.y2,GetColor(b.color));
      return *this;
};
#endif
/* =================================================================================== */
#ifdef INLINE_BUG
GrWindow &
GrWindow::operator<<(const GrCircle &c) 
{
#ifdef DEBUG
    SETFUNC("GrWindow &GrWindow::operator<<(GrCircle &)");
#endif
    grUsrDrawCircle(theWindow,c.x,c.y,c.r,GetColor(c.color));
    return *this;
};
#endif
/* =================================================================================== */
#ifdef INLINE_BUG
GrWindow &
GrWindow::operator<<(const GrFillCircle &c) 
{
#ifdef DEBUG
    SETFUNC("GrWindow &GrWindow::operator<<(GrFillCircle &)");
#endif
    grUsrDrawFillCircle(theWindow,c.x,c.y,c.r,GetColor(c.color));
    return *this;
};
#endif
/* =================================================================================== */
#ifdef INLINE_BUG
GrWindow &
GrWindow::operator<<(const GrFillArc &a) 
{
#ifdef DEBUG
    SETFUNC("GrWindow &GrWindow::operator<<(GrFillArc &)");
#endif
    grUsrDrawFillArc(theWindow,a.x,a.y,a.r,a.a1,a.a2,GetColor(a.color));
    return *this;
};
#endif
/* =================================================================================== */
#ifdef INLINE_BUG
INT 
GrWindow::HorizontalOverlap(REAL x,CHAR *s) 
{
#ifdef DEBUG
    SETFUNC("INT GrWindow::HorizontalOverlap(REAL,CHAR *");
#endif
    return grUsrHorizontalOverlap(theWindow,x,s);
};
#endif

/* =================================================================================== */
#ifdef INLINE_BUG
INT 
GrWindow::VerticalOverlap(REAL y,CHAR *) {
#ifdef DEBUG
    SETFUNC("INT GrWindow::VerticalOverlap(REAL,CHAR *");
#endif
    return grUsrVerticalOverlap(theWindow,y,s);
};
#endif
/* =================================================================================== */
#undef ParentClass
