/*      file     : mpi/TMPIBuffer.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TMPIBuffer.h,v 1.4 2005/05/01 14:57:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TMPIBUFFER_H
#define TMPIBUFFER_H

// ***INCLUDES************************************************************************ 

#include <TBaseObject.h>
#include <TDLList.h>

// ***CLASSES************************************************************************* 

class TMPIBuffer : public TBaseObject, public TDLNodePrimitive

{
public:

    TMPIBuffer(long theSize);
    virtual ~TMPIBuffer(void);

    void
        Activate(TBaseObject *theUser);
    inline bool
        Check(int DesiredSize) const;
    void
        Deactivate(void);
    inline char *
        GetBase(void) const;
    inline int &
        GetPosition(void);
    inline long
        GetSize(void) const;

private:

    virtual TString
        GetClassName(void) const;

    TBaseObject *User;
    char        *Base;
    bool         Active;
    int          Position;
    long         Size;
};

// ***EXTERNALS*********************************************************************** 

extern TDLList<TMPIBuffer> MPIFreeBuffers;
extern TDLList<TMPIBuffer> MPIUsedBuffers;

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TMPIBuffer.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
