/*      file     : parallel/ParallelConfig.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: ParallelConfig.h,v 1.6 2005/03/25 11:06:20 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef PARALLELCONFIG_H
#define PARALLELCONFIG_H

// ***DEFINES************************************************************************* 

/** @name Configuration Group Parallel
  The configuration group [Parallel] understands the following names:
  \begin{itemize}
  \item {\bf UseGrid;} Use {\tt TGridTopology} instead of {\tt TBusTopology}.
  \item {\bf GridRows=N;} Force the number of grid rows to be {\tt N}.
  \item {\bf GridCols=N;} Force the number of grid cols to be {\tt N}.
  \item {\bf BroadcastConfig;} Triggers broadcast of complete configuration
  to all slaves during TParallel::Activate. 
  \end{itemize}
  */

#define PARALLEL_GROUP                 "Parallel"
#define PARALLEL_NAME_USEGRID          "UseGrid"
#define PARALLEL_NAME_GRIDROWS         "GridRows"
#define PARALLEL_NAME_GRIDCOLS         "GridCols"
#define PARALLEL_NAME_BROADCAST_CONFIG "BroadcastConfig"
#define PARALLEL_NAME_MESSAGETIMEOUT   "MessageTimeOut"

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
