/*      file     : parallel/TDestination.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TDestination.i.C,v 1.4 2005/03/25 11:06:20 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline TDestFlags
TDestination::GetFlags(void) const

{
    return Mutable->Flags;
}

// =================================================================================== 

inline TCPNID
TDestination::GetRecipient(void) const

{
    return Recipient;
}

// =================================================================================== 

inline long
TDestination::GetNrOfRecipients(void) const

{
    switch (Recipient)
    {
    case DEST_LIST:
    case DEST_ALL:
    case DEST_ALL_BUT_MYSELF:
        if (!CheckRecipients())
            return FALSE;
        break;
    }
    return Mutable->NrOfRecipients;
}

// =================================================================================== 

inline const TCPNID *
TDestination::GetRecipients(void) const

{
    if (!CheckRecipients())
        return FALSE;
    return Mutable->Recipients;
}

// =================================================================================== 
