/*      file     : parallel/TTopology.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TTopology.i.C,v 1.5 2005/03/25 11:06:21 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline int
TTopology::GetNormalizedRank(int aRank) const

{
    return (aRank + GetNrOfCPN()) % GetNrOfCPN();
}

// =================================================================================== 

inline int
TTopology::GetNrOfCPN(void) const

{
    return (int) List->GetNrOfElements();
}

// =================================================================================== 

inline int
TTopology::GetPrevRank(int aRank) const

{
    if (aRank == TOPOLOGY_MY_RANK)
        aRank = GetRank();
    return GetNormalizedRank(aRank - 1);
}

// =================================================================================== 

inline int
TTopology::GetNextRank(int aRank) const

{
    if (aRank == TOPOLOGY_MY_RANK)
        aRank = GetRank();
    return GetNormalizedRank(aRank + 1);
}

// =================================================================================== 
