/*      file     : parbalance/TLoadStat.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TLoadStat.i.C,v 1.6 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline double
TLoadStat::GetAverageApplicationLoad(void) const

{
    return SecureDiv(ApplicationLoad, (double) (Interval * NrOfSamples));
}

// =================================================================================== 

inline double
TLoadStat::GetAverageApplicationTime(void) const

{
    return SecureDiv(ApplicationTime, (double) (Interval * NrOfSamples));
}

// =================================================================================== 

inline double
TLoadStat::GetAverageIdleTime(void) const

{
    return SecureDiv(IdleTime, (double) (Interval * NrOfSamples));
}

// =================================================================================== 

inline double
TLoadStat::GetAverageMiscTime(void) const

{
    return SecureDiv(MiscTime, (double) (Interval * NrOfSamples));
}

// =================================================================================== 

inline double
TLoadStat::GetAverageStatTime(void) const

{
    return SecureDiv(StatTime, (double) (Interval * NrOfSamples));
}

// =================================================================================== 

inline double
TLoadStat::GetAverageSumTime(void) const

{
    return SecureDiv(ApplicationTime + IdleTime + MiscTime, 
                     (double) (Interval * NrOfSamples));
}

// =================================================================================== 

inline double
TLoadStat::GetMinApplicationTime(void) const

{
    return SecureDiv(MinApplicationTime, Interval);
}

// =================================================================================== 

inline double
TLoadStat::GetMinStatTime(void) const

{
    return SecureDiv(MinStatTime, Interval);
}

// =================================================================================== 

inline double
TLoadStat::GetMaxApplicationTime(void) const

{
    return SecureDiv(MaxApplicationTime, Interval);
}

// =================================================================================== 

inline double
TLoadStat::GetMaxStatTime(void) const

{
    return SecureDiv(MaxStatTime, Interval);
}

// =================================================================================== 

inline double
TLoadStat::GetMinIdleTime(void) const

{
    return SecureDiv(MinIdleTime, Interval);
}

// =================================================================================== 

inline double
TLoadStat::GetMaxIdleTime(void) const

{
    return SecureDiv(MaxIdleTime, Interval);
}

// =================================================================================== 

inline double
TLoadStat::GetMinMiscTime(void) const

{
    return SecureDiv(MinMiscTime, Interval);
}

// =================================================================================== 

inline double
TLoadStat::GetMaxMiscTime(void) const

{
    return SecureDiv(MaxMiscTime, Interval);
}

// =================================================================================== 

inline double
TLoadStat::GetAverageEffectiveTime(void) const

{
    return SecureDiv(GetAverageApplicationLoad(), GetAveragePerf());
}

// =================================================================================== 

inline double
TLoadStat::GetAveragePerf(void) const

{
    return SecureDiv(Perf, (double) NrOfSamples);
}

// =================================================================================== 

inline double
TLoadStat::GetMinPerf(void) const

{
    return MinPerf;
}

// =================================================================================== 

inline double
TLoadStat::GetMaxPerf(void) const

{
    return MaxPerf;
}

// =================================================================================== 
