/*      file     : parstat/TStatHandler.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TStatHandler.C,v 1.5 2005/03/25 11:08:01 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TEnvironment.h>

#include "TAggregationInfo.h"
#include "TSamplingDescription.h"
#include "TStatObject.h"
#include "TStatHandler.h"

// ***METHODS************************************************************************* 

bool
TStatHandler::Collect(TSamplingDescription *Description)

{
    Print("TStatHandler::Collect not overwritten for %s ", 
          (char *) Description->GetInstanceName());
    return FALSE;
}

// =================================================================================== 

bool
TStatHandler::HandleAggregationResult(TAggregationInfo *AggregationInfo, 
                                      TTimeStep &TimeStep)

{
    Print("TStatHandler::HandleAggregationResult not overwritten for %s in time-step %s", 
          (char *) AggregationInfo->GetInstanceName(), 
          (char *) TimeStep.GetInstanceName());
    return FALSE;
}

// =================================================================================== 

bool
TStatHandler::Sample(TSamplingDescription *Description)

{
    Print("TStatHandler::Sample not overwritten for %s ", 
          (char *) Description->GetInstanceName());
    return FALSE;
}

// =================================================================================== 

