/*      file     : parstat/TTimeLookup.C
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TTimeLookup.C,v 1.5 2005/03/25 11:08:01 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include "TTimeLookup.h"

// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***GLOBAL VARIABLES****************************************************************  
// ***LOCAL VARIABLES***************************************************************** 
// ***FUNCTIONS*********************************************************************** 
// ***METHODS************************************************************************* 

#ifdef NO_INLINE
#endif

// =================================================================================== 

// =================================================================================== 
#define ParentClass TParallelObject
// =================================================================================== 

TTimeLookup::TTimeLookup(TClassInfo *theClassInfo, TParallelID theParallelID) :

ParentClass(theClassInfo, theParallelID)

{
    Default = 0;
}

// =================================================================================== 

TTimeLookup::~TTimeLookup(void)

{
}

// =================================================================================== 

bool
TTimeLookup::Get(long TimeStep, TStatObject *&First, double &FirstWeight,
                 TStatObject *&Second, double &SecondWeight)

{
    if (Entries.GetNrOfItems() == 0)
        return FALSE;
    First = Second = Entries[Entries.GetNrOfItems() - 1];
    FirstWeight = SecondWeight = 0.5;
    return TRUE;
}

// =================================================================================== 

bool
TTimeLookup::GetLatest(TStatObject *&Latest)

{
    if (Entries.GetNrOfItems() == 0)
        return FALSE;
    Latest = Entries[Entries.GetNrOfItems() - 1];
    return TRUE;
}

// =================================================================================== 

bool
TTimeLookup::Put(TStatObject *StatObject, bool Add)

{
    if (Add OR Entries.GetNrOfItems() == 0)
        return Entries.Add(StatObject);
    else
    {
        long LastEntry = Entries.GetNrOfItems() - 1;
                                
        DeleteObject(Entries[LastEntry]);
        Entries[LastEntry] = StatObject;
    }
    return TRUE;
}

// =================================================================================== 
#undef ParentClass
