/*      file     : partools/TBaseDataManager.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TBaseDataManager.h,v 1.3 2005/03/25 11:08:14 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TBASEDataManager_H
#define TBASEDataManager_H

// ***INCLUDES************************************************************************ 

#include <TID2ContainerEntry.h>
#include <TABTree.h>
#include <TParallelObject.h>
#include <TObjectHandler.h>

// ***FORWARDS************************************************************************

#include <TNode.forward.h>
#include <TEdge.forward.h>

// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 

typedef TID2ContainerEntry < TEdge > TIncidenceTableEntry;
typedef TABTree< TIncidenceTableEntry > TIncidenceTable;

// ***CLASSES************************************************************************* 

class TBaseDataManager : public TBaseObject, public TObjectHandler

{
public:

    TBaseDataManager(void);

    virtual bool
    Activate(void);

    /*
    bool
    GenerateIncidenceInfo(TNode *Node);

    bool
    InsertIncidences(TEdge *Edge);
    */

    bool
    Run(void);

private:

    /*
    bool
    DisposeIncidenceInfo(TParallelID NodeID);
    */

    virtual TString
    GetClassName(void) const;

    /*
    virtual bool
    HandleAction(TParallelObject *Object, TObjectAction Action);
    */

    virtual bool
    HandleCreateRequest(TParallelObject *&Object, const TClassInfo *ClassInfo, 
                        TParallelID ParallelID);
    /*
    virtual bool
    HandleLoadRequest(TParallelObject *Object, bool &Loaded);

    bool
    RemoveIncidences(TEdge *Edge);

    TIncidenceTable IncidenceTable;
    */
};


// ***EXTERNALS*********************************************************************** 
// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#endif
// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
