/*      file     : partools/TBoundary.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TBoundary.h,v 1.4 2005/03/25 11:08:14 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TBOUNDARY_H
#define TBOUNDARY_H

// ***INCLUDES************************************************************************ 

#include <TParallelListObject.h>

// ***FORWARDS************************************************************************

class TClassInfo;
class TBaseStream;

// ***CLASSES************************************************************************* 

class TBoundary : public TParallelListObject

{
public:

    TBoundary(TClassInfo *ClassInfo, TParallelObject *theDistributedObject);
    TBoundary(TClassInfo *ClassInfo, TParallelID theParallelID);

    virtual bool
    Assign(void) = 0;

    virtual TString
    GetClassName(void) const;

    virtual TString
    GetInstanceName(void) const;

    void
    SetSender(TCPNID theSender);
    
protected:
    
    bool
    Decode(TBaseStream *Stream, TTransferInfo *TransferInfo);

    bool
    Encode(TBaseStream *Stream, TTransferInfo *TransferInfo) const;

    TParallelObject *
        GetDistributedObject(void) const;
    
private:

    TCPNID                        Sender;
    TClassID                      ObjectClassID;
    MUTABLE_DECL TParallelObject *DistributedObject;
};

// ***TYPES*************************************************************************** 

typedef TDLList< TBoundary > TBoundaryList;
typedef TDLListEnum < TBoundary > TBoundaryEnum;

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
