/*      file     : partools/TIncidenceInfo.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TIncidenceInfo.h,v 1.8 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TINCIDENCEINFO_H
#define TINCIDENCEINFO_H

// ***INCLUDES************************************************************************ 

#include <stdlib.h>

#include <TParallelObject.h>

// ***FORWARDS************************************************************************

class TClassInfo;

#include "TEdge.forward.h"

// ***CLASSES************************************************************************* 

class TIncidenceInfo : public TParallelObject

{
public:

    TIncidenceInfo(TClassInfo *ClassInfo, TParallelID theParallelID);    
    virtual ~TIncidenceInfo(void);

    bool
    AssignEdges(int theNrOfInEdges, TParallelID  *theInEdges,
                int theNrOfOutEdges, TParallelID *theOutEdges);

    inline TEdge *
    GetIncomingEdge(int EdgeNr, bool IssueWarning = TRUE) const;

    inline TEdge *
    GetOutgoingEdge(int EdgeNr, bool IssueWarning = TRUE) const;

    inline int
    GetNrOfIncomingEdges(void) const;

    inline int
    GetNrOfOutgoingEdges(void) const;
    /*
    bool
    IsSimpleConnection(void);
    */
    bool
    Sort(void);

    static TClassInfo *ClassInfo;

private:

    bool
    Allocate(void);

    virtual bool
    Decode(TBaseStream *Stream, TTransferInfo *TransferInfo);

    virtual bool
    Encode(TBaseStream *Stream, TTransferInfo *TransferInfo) const;

    virtual TString
    GetClassName(void) const;

    virtual TString
    GetInstanceName(void) const;

    short int    NrOfInEdges;
    short int    NrOfOutEdges;
    TParallelID *InEdges;
    TParallelID *OutEdges;
};

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TIncidenceInfo.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
