/*      file     : partools/TIncidenceInfo.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TIncidenceInfo.i.C,v 1.5 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TEdge.h>

// ***METHODS************************************************************************* 

inline TEdge *
TIncidenceInfo::GetIncomingEdge(int EdgeNr, bool IssueWarning) const

{
    TEdge *Edge;

    if ((Edge = TEdge::GetPtr(InEdges[EdgeNr])) == 0)
    {
        if (IssueWarning)
            Warning("GetIncomingEdge: cannot retrieve edge %ld", InEdges[EdgeNr]);
        return FALSE;
    }
    return Edge;
}

// =================================================================================== 

inline TEdge *
TIncidenceInfo::GetOutgoingEdge(int EdgeNr, bool IssueWarning) const

{
    TEdge *Edge;

    if ((Edge = TEdge::GetPtr(OutEdges[EdgeNr])) == 0)
    {
        if (IssueWarning)
            Warning("GetOutgoingEdge: cannot retrieve edge %ld", OutEdges[EdgeNr]);
        return FALSE;
    }
    return Edge;
}

// =================================================================================== 

inline int
TIncidenceInfo::GetNrOfIncomingEdges(void) const

{
    return NrOfInEdges;
}

// =================================================================================== 

inline int
TIncidenceInfo::GetNrOfOutgoingEdges(void) const

{
    return NrOfOutEdges;
}

// =================================================================================== 
