/*      file     : pvm/LocalPvm.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: LocalPvm.C,v 1.6 2005/03/25 11:08:25 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <string.h>

#include "TEnvironment.h"

#include "LocalPvm.h"

// ***LOCAL VARIABLES***************************************************************** 

int CurrentArchCode = -1;

// ***FUNCTIONS*********************************************************************** 

int
PvmArchCode(const char *ArchName)

{
#ifdef NO_PVM_ARCHCODE
    static Warned = FALSE;

    if (!Warned)
    {
        Print("WARNING: pvm_archcode not supported, returning %d for arch '%s'",
              CurrentArchCode, ArchName);
        Warned = TRUE;
    }
    return CurrentArchCode;
#else
    return pvm_archcode((char *) ArchName);
#endif
}

// =================================================================================== 
#ifdef NO_PVM_CATCHOUT

void
PvmCatchOut(FILE *)

{
    Print("WARNING: pvm_catchout not supported");
}

#else

void
PvmCatchOut(FILE *theFile)

{    
    pvm_catchout(theFile);
}

#endif
// =================================================================================== 

int
PvmMyTID(void)

{
#ifdef PVM_MYTID
    int MyTID;

    if ((MyTID = pvm_mytid()) < 0)
        return MyTID;
    else
        return PVM_MYTID;
#else
    return pvm_mytid();
#endif
}

// =================================================================================== 

int
PvmTID(struct pvmhostinfo* HostInfo)

{
    static bool Warning = FALSE;

    if (strcmp(HostInfo->hi_arch, "PowerPVM") == 0)
    {
        if (!Warning)
        {
            Print("WARNING: converting TID-mask %X into %X",
                  POWERPVM_TID_MASK, POWERPVM_TID(POWERPVM_TID_MASK));
            Warning = TRUE;
        }
        return POWERPVM_TID(HostInfo->hi_tid);
    }
    else
        return HostInfo->hi_tid;
}

// =================================================================================== 
