/*      file     : pvm/TPVMMessageControl.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TPVMMessageControl.h,v 1.9 2005/03/25 11:08:26 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TPVMMESSAGECONTROL_H
#define TPVMMESSAGECONTROL_H

// ***INCLUDES************************************************************************ 

#include <TString.h>

#include <ParallelTypes.h>
#include <TCommunicationControl.h>

// ***CLASSES************************************************************************* 

class TPVMMessageControl : public TCommunicationControl

{
public:

    TPVMMessageControl(void);

private:

    virtual long
        GetCapabilities(void) const;
    virtual TString
        GetClassName(void) const;
    virtual TBaseMessage *
        GetNewMessage(TMessageID theID, TCPNID theSender, 
                      TDestination *theDestination, TMessageTag theTag, 
                      TMessageType theType, TMessageFlags theFlags);
    void
        _Init(void);
    virtual bool
        IsBlockable(void) const;
    virtual bool
        MessageIsPending(void) const;
    virtual bool
        ReceiveMessage(TBaseMessage *&theMessage, long TimeOut);
    bool
        ReceiveRegularMessage(int BufferID, TCPNID theSender, TBaseMessage *&theMessage);
    virtual bool
        SetEncoding(TEncodingMode theEncoding);

    int     Encoding;
    TString HostFilename;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
